/*
 * Global.h
 *
 *  Created on: 2022年4月6日
 *      Author: 86137
 */

#ifndef GLOBAL_GLOBAL_H_
#define GLOBAL_GLOBAL_H_

#include "hal_data.h"
#include "math.h"
#include "pwm/pwm.h"
#include "adc/adc.h"
#include "leds/leds.h"
#include "keys/keys.h"
#include "oled/oled.h"
#include "PID/pid.h"
#include "Temperature/Temperature.h"

extern float ADC_val[27];//存储ADC电压


//ADC采样通道相关变量定义
#define channel_Vin                 ADC_CHANNEL_6
#define channel_Iin                 ADC_CHANNEL_5
#define channel_VDC                 ADC_CHANNEL_4
#define channel_IDC                 ADC_CHANNEL_2
#define channel_VAC                 ADC_CHANNEL_0
#define channel_IAC                 ADC_CHANNEL_1
#define channel_temperature1        ADC_CHANNEL_7
#define channel_temperature2        ADC_CHANNEL_8
//AD channel change for AD order
#define ADC_Vin                     ADC_val[6]
#define ADC_Iin                     ADC_val[5]
#define ADC_VDC                     ADC_val[4]
#define ADC_IDC                     ADC_val[2]
#define ADC_VAC                     ADC_val[0]
#define ADC_IAC                     ADC_val[1]
#define ADC_Temp1                   ADC_val[7]
#define ADC_Temp2                   ADC_val[8]

#define SCL              BSP_IO_PORT_04_PIN_00
#define SDA              BSP_IO_PORT_04_PIN_01
#define Delay_60Mhz      __NOP();__NOP();__NOP();__NOP()

#define Yes              1
#define No               0


#define Delay_us(us)     R_BSP_SoftwareDelay(us,BSP_DELAY_UNITS_MICROSECONDS)
#define Delay_ms(ms)     R_BSP_SoftwareDelay(ms,BSP_DELAY_UNITS_MILLISECONDS)
#define Delay_s(s)       R_BSP_SoftwareDelay(s,BSP_DELAY_UNITS_SECONDS)
#define Pi               4.0*atan(1.0)

/* Macro to set value to output voltage control*/
#define VREFADCG_ENABLE   0x18
/* Macro to set value to enable VREFADC output*/
#define VREFADCG_VALUE    0x06
#define RESET_VALUE             (0x00)

#define Boost_30Khz         (1666)
#define SPWM_Fre_30KHz      (1667)
#define SPWM_Fre_60Hz       (52083)
#define SPWM_Fre_25KHz      (2000)
#define SPWM_Fre_50Hz       (62500)//GPT时钟被  16分频(1000000)

extern fsp_err_t err;
extern int timeout_ms;
extern volatile bool scan_complete_flag;

//标志位声明
extern uint8_t     Mode;

extern _Bool Over_Current;
extern _Bool Short_Circuit;

extern float      Boost_PWM_PhaseSet;




extern float      M;
extern float      V_out;
extern float      I_out;
extern float      V_DC_bias;

extern float V_in;
extern float I_in;

extern float V_DC;
extern float I_DC;

extern float V_DC_bias;
extern float V_in_bias;

extern float AC_mul;
extern float DC_mul;
extern float IN_mul;


extern float temperature1;
extern float temperature2;
extern PIDVARS PidVAC;
extern PIDVARS PidVDC;

extern uint16_t OC_CNT;
extern uint8_t OC_time;

extern _Bool Mode_choice;
extern _Bool Mode_AC_50Hz;


#endif /* GLOBAL_GLOBAL_H_ */
