/*
 * pid.h
 *
 *  Created on: 2022年6月1日
 *      Author: 86137
 */

#ifndef PID_PID_H_
#define PID_PID_H_

#include "PID/IQmathLib.h"

#define PID_Q       _IQ19
#define PID_Qmpy    _IQ19mpy
#define PID_Qdiv    _IQ19div

typedef struct {
    float  Ref;               // Input: Reference input
                  float  Fdb;               // Input: Feedback input

                  float  Err[3];               // Variable: Error

                  float  Up;           // Variable: Proportional output
                  float  Ui;           // Variable: Integral output
                  float  Ud;           // Variable: Derivative output

                  float  OutMin;           // Parameter: Minimum output
                  float  OutMax;           // Parameter: Maximum output
                  float  OutPreSat;        // Variable: Pre-saturated output
                  float  Out;                  // Output: PID output
                  float  SatErr;               // Variable: Saturated difference

                  float  Kp;           // Parameter: Proportional gain
                  float  Ki;           // Parameter: Integral gain
                  float  Kd;           // Parameter: Derivative gain

                  float  Ke;                   // Parameter: Integral threshold value
                  float  Kc;                   // Parameter: Integral correction gain

                  void  (*Calc)();      // Pointer to calculation function
                 } PIDVARS;             // PIDVARS


extern void PidCalc(PIDVARS *PidObj);

extern PIDVARS PidVout;






#endif /* PID_PID_H_ */
