/*
 * pwm.c
 *
 *  Created on: 2022年4月6日
 *      Author: 86137
 */

#include "pwm.h"
#include "r_gpt.h"






void SPWM_DutyCycleSet(uint32_t const duty_cycle_counts)
{
    R_GPT_DutyCycleSet(&inverter_ctrl, duty_cycle_counts,GPT_IO_PIN_GTIOCA_AND_GTIOCB);
}

void PWM_OutPut_Enable()
{
    R_GPT_OutputEnable(&boost_inter_ctrl, GPT_IO_PIN_GTIOCA_AND_GTIOCB);
    R_GPT_OutputEnable(&boost_cross_ctrl, GPT_IO_PIN_GTIOCA_AND_GTIOCB);
    R_GPT_OutputEnable(&out50hz_ctrl, GPT_IO_PIN_GTIOCA_AND_GTIOCB);
    R_GPT_OutputEnable(&inverter_ctrl, GPT_IO_PIN_GTIOCA_AND_GTIOCB);
}

void PWM_OutPut_Disable()
{
    R_GPT_OutputDisable(&boost_inter_ctrl, GPT_IO_PIN_GTIOCA_AND_GTIOCB);
    R_GPT_OutputDisable(&boost_cross_ctrl, GPT_IO_PIN_GTIOCA_AND_GTIOCB);
    R_GPT_OutputDisable(&out50hz_ctrl, GPT_IO_PIN_GTIOCA_AND_GTIOCB);
    R_GPT_OutputDisable(&inverter_ctrl, GPT_IO_PIN_GTIOCA_AND_GTIOCB);
}



void Boost_DutyCycleSet(uint32_t const duty_cycle_counts)
{
    R_GPT_DutyCycleSet(&boost_inter_ctrl, Boost_30Khz-duty_cycle_counts, GPT_IO_PIN_GTIOCA);
    R_GPT_DutyCycleSet(&boost_cross_ctrl, Boost_30Khz-duty_cycle_counts, GPT_IO_PIN_GTIOCA);
}


void Boost_OutPut_Enable()
{
    R_GPT_OutputEnable(&boost_inter_ctrl, GPT_IO_PIN_GTIOCA_AND_GTIOCB);
    R_GPT_OutputEnable(&boost_cross_ctrl, GPT_IO_PIN_GTIOCA_AND_GTIOCB);
}

void Boost_OutPut_Disable()
{
    R_GPT_OutputDisable(&boost_inter_ctrl, GPT_IO_PIN_GTIOCA_AND_GTIOCB);
    R_GPT_OutputDisable(&boost_cross_ctrl, GPT_IO_PIN_GTIOCA_AND_GTIOCB);
}

void SPWM_OutPut_Enable()
{
    R_GPT_OutputEnable(&out50hz_ctrl, GPT_IO_PIN_GTIOCA_AND_GTIOCB);
    R_GPT_OutputEnable(&inverter_ctrl, GPT_IO_PIN_GTIOCA_AND_GTIOCB);
}

void SPWM_OutPut_Disable()
{
    R_GPT_OutputDisable(&out50hz_ctrl, GPT_IO_PIN_GTIOCA_AND_GTIOCB);
    R_GPT_OutputDisable(&inverter_ctrl, GPT_IO_PIN_GTIOCA_AND_GTIOCB);
}

void Init_PWM_50Hz()
{


    R_GPT_Open(&boost_inter_ctrl, &boost_inter_cfg);//打开GPT0，将configuration文件里的参数配置给GPT0 GPT0 40KHz 交错并联Boost波1
    R_GPT_Open(&boost_cross_ctrl, &boost_cross_cfg);//打开GPT1，将configuration文件里的参数配置给GPT1 GPT1 40KHz 交错并联Boost波2
    R_GPT_Open(&out50hz_ctrl, &out50hz_cfg);//打开GPT2，将configuration文件里的参数配置给GPT2 GPT2 50Hz 逆变器低频波
    R_GPT_Open(&inverter_ctrl, &inverter_cfg);//打开GPT3，将configuration文件里的参数配置给GPT3 GPT3 25KHz SPWM 逆变器高频波
     R_GPT_Start(&boost_inter_ctrl);//开始GPT0 交错并联boost1
    /*使用延时GPT1开始发波来达到移相的效果
     *GPT0 GPT1 均工作在三角波模式，A通道是开始低电平，到达比较值时电平翻转，结束是为低电平。
     *其高电平在中间段，比如GPT0(50Hz)50%的占空比，先低电平(5ms)再高电平(10ms)最后低电平(5ms)
     *交错并联控制波形相差180°相位，通过延时开始发波达到移相的效果
     */
     Delay_us(15);
     for(uint8_t i=0;i<18;i++)//使用空指令来进行微调
          __NOP();
    R_GPT_Start(&boost_cross_ctrl);//开始GPT1 交错并联boost2

    R_GPT_Start(&out50hz_ctrl);//开始GPT2 逆变器低频波
    //使用延时GPT3开始发波来达到移相的效果，使得当低频波为高电平时，SPWM的占空比从小到大再从大到小变化
    Delay_ms(14);
    Delay_us(998);
       for(uint8_t i=0;i<22;i++)//使用空指令来进行微调
           __NOP();
    R_GPT_Start(&inverter_ctrl);//开始GPT3 SPWM 逆变器高频波

    R_GPT_PeriodSet(&out50hz_ctrl,SPWM_Fre_50Hz);//设置为50Hz
    R_GPT_DutyCycleSet(&out50hz_ctrl, SPWM_Fre_50Hz/2, GPT_IO_PIN_GTIOCA_AND_GTIOCB);
    R_GPT_PeriodSet(&inverter_ctrl,SPWM_Fre_25KHz);//设置为25KHz
}
